;+
; Mission:
;  ASO-S/HXI
; Name:
;  HXI_DATA_PATHS
;
; Purpose:
;  This function returns all the directories needed for a HXI data path.
;  
; Call sequence:
;  paths= hxi_data_paths() 
;
; Inputs:
;  none
; Outputs:
;  data path include
;  1. current directory,
;  2. hxi_data_archive
;  3. hxi_data_user and its subdirectories
;
;History:
;  Weichen, 2022/2/19
;

FUNCTION hxi_data_paths

path= curdir()
delim   = path_sep() 

;230519,YS,->lower case 
;SETENV, 'hxi_data_archive=E:'+delim+'ASO'+delim+'HXI'+delim+'testdata'
;SETENV, 'hxi_data_archive='+path+delim+'data'
mounted = stregex(getenv('hxi_data_archive'), 't', /bool, /fold)
 if mounted then path=[path,getenv('hxi_data_archive')]

;SETENV, 'hxi_data_user=E:\HXI\testdata'
if is_dir (getenv('HXI_DATA_USER')) then path= [path, getenv('HXI_DATA_USER')]  ;240308 

return, path[uniq(path)]

END