;+
; Mission     : ASO-S/HXI
; Name        : hxi_filetype
; Purpose     : return the type of opend file
; Written: Fanxiaoyu Xia, 2020/08/07
;   2022/11/03, yang su, add support for reading maps from other FITS

function hxi_filetype, filename,ftype

  if strmatch(filename, '*hxi_*levq1_*.fits', /fold_case) eq 1 then begin
    return, 'ql'
  endif else begin
    if strmatch(filename, '*hxi_*lev10_*.fits', /fold_case) eq 1 then begin
    return, 'sp'
    endif
  
    if strmatch(filename, '*hxi_imgcube_*.fits', /fold_case) eq 1 then begin
      return, 'im'
    endif
    
    ;check on the data, standard image or not, fits_define, 221103, yang su, 
  ;  readfits(filename,data,index=index,_extra=extra,err= err,$
  ;    extension=rext,nodata=nodata)
  ;  ddim=size(data,/n_dim)
  
  ;  if ~nodata && (is_string(terr) || (ndim le 1) || (ndim gt 3) || is_struct(data)) then begin
  ;    if is_blank(terr) then terr='Warning - FITS file contains a non-standard image.'
  ;    ;   mprint,terr,/info
  ;    continue
  ;  endif
    
    ; add support for other maps, 221103, yang su
    fits2map, filename, tempmap, err=err 
    if is_struct(tempmap) and is_blank(err) then begin
      return, 'im'
    endif
    
    return, '-1'
  endelse

end