;+
; Mission:
;   ASO-S/HXI
; Purpose: 
;   find closest index in array
; Inputs:
;   arr   -- source array
;   u     -- target value  
; Output:
;   index   
; Keyword: 
;   value -- print the closest value
; History: 
;   2020/05/28,  WeiChen, 1st
;   2022/08/28, WeiChen,

FUNCTION closest_ix,arr,u,value=value


  if (data_type(arr) OR data_type(u)) EQ 0  OR n_elements(arr) LE 1 then begin
    on_error,2
    err='invalid input structures'
    message,err,level=2;,/info
    return,-1
  endif

  n = n_elements(u)
  ix = lonarr(n)
  value=ix*arr(0)


  for i=0, n-1 do begin

    newarr= arr-u[i]
    v= min(abs(newarr),idx)
    ix[i]=idx
    value[i]=arr[idx]
  endfor

  return,ix

  if keyword_set(value) then  return,value


END
