;+
; Mission:
;   ASO-S/HXI
; Puropse:
;   Read HXI flare list info
; Input:
;   None
; Option Input:
;   flare_id
; Outputs:
;   struct infomation about flare
; History:
;   Weichen,  2021/08/10
;   Weichen,  2022/05/18, modify to read .sav file 

Function hxi_rd_flarelist, flare_id, err_msg=err_msg

  err_msg=''
  
  dir = getenv('hxi_dbase') ;230519, YS
  wfile = 'HXI_flarelist*.sav'
  path=[hxi_data_paths(),dir]
  file= file_search(path, wfile, count=nf)
  
  if nf eq 0 then begin
    err_msg = 'No flare files to read.'
    message, err_msg, /cont
    return,-1
  endif
  file=file[nf-1]
  
 ; r=json_parse(file,/tostruct)
 ;r= rd_tfile(file,/convert,head=head)
  restore, file
  ;help,hxi_flist,/str
   ind= where(long(flare_id) eq hxi_flist.flare_id, nn)
   if nn eq 0 then begin
     print, 'Cant find the flare of '+ trim(flare_id) +' in your catalogue.'
     return, -1
   endif
  

 out = {startt: hxi_flist[ind].startt, $
        endt:   hxi_flist[ind].endt,   $
        peakt:  hxi_flist[ind].peakt,  $
        peakt_h:hxi_flist[ind].peakt_h };,$
       ; xyoffset:hxi_flist[ind].xyoffset    }
  
  RETURN, out      
        
  
  
 
END