;+
; Mission     : ASO-S/HXI
; HISTORY:
;  Writen by Fanxiaoyu Xia, 2022/08/19
;  2022/08/19, Yang su, added hxi_para, call 'hxi_write_imagecube'
;  2022/09/18, Fanxiaoyu Xia, when save the images from a HXI_imagecube file, return error.

pro hxi_image::output,tarray=tarray, enebins=enebins
  if Ptr_Valid(self.image_str) then begin
    if  ~is_struct(*self.image_str) then begin 
      a = dialog_message('Cannot save from fits files')
      return 
    endif
    data_str=*self.image_str
 
    flareloc = [data_str[0].xc, data_str[0].yc]
    imdim =  size(data_str,/dim)  
    img_e = enebins
    img_t = tarray
 
    hxi_para= { FLARE_ID_NR: 0L , $
                IMAGE_ALGORITHM: data_str[0].Algorith, $
                IMAGE_DIM: imdim, $
                pointing: [0.,0.], $
                PIXEL_SCALE: 1., $
                PIXEL_SIZE: [data_str[0].dx, data_str[0].dy], $
                ENERGY_BAND: img_e, $
                TIME_INTERVALS: img_t, $
                IMAGING_POWER_LAW: 4., $
          
                XYOFFSET: flareloc , $
                FLARE_XYOFFSET: flareloc, $
                USE_FLARE_XYOFFSET: 1, $
          
                DET_MASK: intarr(91)+1, $
                LIVETIME_ENABLE: 1., $
                USE_TOTAL_COUNT: 1, $

                FILE_TYPE: 'FITS', $
                WEIGHT: 1, $
                NATURAL_WEIGHTING: 0, $
                UNIFORM_WEIGHTING: 1, $
                SPATIAL_FREQUENCY_WEIGHT: fltarr(10)+1., $
                total_counts: data_str.counts, $
                bg_counts: data_str.bkg  }

    hxi_write_imagecube, tarray,enebins,data_str,hxi_para
  endif else begin
    a = dialog_message('No images to save')
  endelse
end