;+
; Mission     : ASO-S/HXI
; HISTORY:
;  Writen by Fanxiaoyu Xia, 2022/08/19
;  2022/09/17, Fanxiaoyu Xia, added an inquiry, whether the selected detectors need to be merged.
;  2023/10/20, Zhentong Li, the keyword sepdet becomes effective
;  2023/11/03, Zhentong Li, change keyword sepdet to combine_check

pro hxi_spectrum::output, dir=dir, combine_check=combine_check
  if Ptr_Valid(self.spec_str) then begin
    data_str=*self.spec_str
    
    spec4fits = {UT_EDGES: data_str.sptimes4fits, $
                  CT_EDGES: data_str.enebins, $
                  RCOUNTS : data_str.spec4fits, $
                  LTIME :    data_str.splivet4fits}   
                  
    det_index = data_str.collindex
    
    hxi_write_spex_fits,spec4fits,outdir=dir,ebins=spec4fits.CT_EDGES,detectors = det_index, combine_check=combine_check;, sepdet=sepdet
    
  endif else begin
    a = dialog_message('No spectrum to save.')
  endelse
end