;+
; Mission:
;   ASO-S/HXI
; Purpose:
;   get det ids for user selected
; Input:
;   det_ids    -- ids for subcollimator, 0-91
;
; Op. input:
;   det_range  --  e.g. [10,80]
;   subc_group -- e.g. [0,0,1,1,1,1,1,1,0,0]
; Output:
;   user defined detids
; History:
;   Weichen, 2022/08/25, created
;   Weichen, 2022/09/19, hxi-gui can set keywords det_range and subc_group at same time.
;   
;
;
FUNCTION HXI_GET_DETIDS,det_ids, det_range=det_range, subc_group=subc_group

  checkvar, det_ids, INDGEN(91)

  IF ~is_range(det_ids, [0,90]) THEN BEGIN
    MESSAGE, 'Wrong set of detectors id',/con
    RETURN, -1
  ENDIF
 
   ;RETURN, det_ids

;IF KEYWORD_SET(det_range) OR KEYWORD_SET(subc_group) THEN BEGIN   
;;  keywords replaced by total 09/19
;  IF (TOTAL(det_range) GT 0) AND (TOTAL(subc_group) GT 0) THEN BEGIN
;    MESSAGE, 'Cant set both keywrod at same time.'
;  ENDIF ELSE BEGIN
;    ;if ~keyword_set(det_range) AND ~keyword_set(subc_range) AND (n_params() NE 1) then det_ids=indgen(45)
;    IF TOTAL(det_range NE -1) EQ 2 THEN BEGIN    ;when not keyword det_range set , value is [-1,-1]
;      IF  ~is_range(det_range, [0,90]) THEN BEGIN
;        MESSAGE, 'Wrong set of detectors range',/con
;        RETURN, -1
;      ENDIF ELSE BEGIN
;        det_ids= FIX(MIN(det_range))+ INDGEN(MAX(det_range)- MIN(det_range) +1)
;      ENDELSE
;    ENDIF
;    IF TOTAL(subc_group) GT 0 THEN BEGIN
;      IF  N_ELEMENTS(subc_group) NE 10 THEN BEGIN
;        MESSAGE, 'Wrong set of sub_colliator range',/con
;        RETURN, -1
;      ENDIF ELSE BEGIN
;        cmask=hxi_collimator_mask()
;        ind= WHERE(subc_group NE 0)
;        submask= TOTAL( cmask[*,ind],2)
;        det_ids = WHERE( submask EQ 1)
;      ENDELSE
;    ENDIF
;  ENDELSE
;ENDIF

  ;yang, 20221002;221016;230201
  IF KEYWORD_SET(det_range) OR KEYWORD_SET(subc_group) THEN BEGIN
    ;  keywords replaced by total 09/19
    IF KEYWORD_SET(det_range) then begin
      if (TOTAL(det_range eq -1) EQ 2) then begin
        MESSAGE, '!!! detector range is not selected.',/con
  
      endif else begin
        If (TOTAL(det_range NE -1) EQ 2) then begin
          IF  ~is_range(det_range, [0,90]) THEN BEGIN
            MESSAGE, 'Wrong set of detectors range',/con
            RETURN, -1
          endif else begin
            det_ids= FIX(MIN(det_range))+ INDGEN(MAX(det_range)- MIN(det_range) +1)
          endelse
        endif
              
      endelse
    endif
        
    IF KEYWORD_SET(subc_group) then begin
        if  total(subc_group) eq 0 THEN BEGIN
          MESSAGE, '!!! No subcollimator groups are selected.',/con
        endif else begin
          IF  N_ELEMENTS(subc_group) NE 10 THEN BEGIN
            MESSAGE, 'Wrong set of sub_colliator range',/con
            RETURN, -1
          ENDIF ELSE BEGIN
            cmask=hxi_collimator_mask()
            ind= WHERE(subc_group NE 0)
            
            ;230221, yang su
            if n_elements(ind) eq 1 then begin
              submask= reform( cmask[*,ind[0]])
            endif else begin
              submask= TOTAL( cmask[*,ind],2)
            endelse
            
            det_ids = WHERE( submask EQ 1)
          ENDELSE
  
        endelse
        
    endif
        
  endif else begin
      
  endelse

  RETURN,det_ids

END

