;+
; Mission     : ASO-S/HXI
; Puropse:
; Generate composite components that enable users to select flags
; input:
; parent - widget id of widget calling hxi_flag_widget
; Outputs:
; uvalue - user value to assign to compound widget
; History:
; Writen by Fanxiaoyu Xia, 2021/07/20

function hxi_flag_widget_event, event

  base = event.handler
  stash = widget_info(base, /child)
  widget_control, stash, get_uvalue=state
  widget_control, event.id, get_uvalue=uvalue

  if strlen(uvalue) lt 2 then begin
    num=fix(uvalue)
    state.flags_index[num] = event.select
    widget_control, stash, set_uvalue=state
  endif

  if uvalue eq 'all_flags' then begin
    state.flags_index=replicate(1,6)
    for i=0,5 do begin
      widget_control, state.w_flags[i], set_button = state.flags_index[i]
    endfor
    widget_control, stash, set_uvalue=state
  endif

  if uvalue eq 'no_flags' then begin
    state.flags_index=state.fdefault
    for i=0,5 do begin
      widget_control, state.w_flags[i], set_button = 0
    endfor
    widget_control, stash, set_uvalue=state
  endif

  ret = {id: base, top: event.top, handler: 0L}
  return,ret
end

function hxi_flag_widget, parent, uvalue=uvalue
  w_flags= lonarr(6)
  flag_base = widget_base (parent, /column, /frame, $
    /base_align_left, uvalue=uvalue, $
    event_func='hxi_flag_widget_event', $
    title='Flags Options')
  base2=widget_base(flag_base, /column)
  base20=widget_base(base2, /row, /align_left, space=60)  ;YS, 230512 
  tmp = widget_label (base20, value='Select Flags to Display:  ', /align_left)
  base21 = widget_base(base2, /column, /align_left)
  w_flag = widget_base(base21,  column=3,  /nonexclusive,  /align_left );YS, 230512 
  flag_names = ['Off Pointing', 'Night', 'SAA', 'Calibration', $
        'Burst Mode', 'Flare'] ;YS, 230512
  w_flags[0] = widget_button(w_flag, value=flag_names[0], uvalue='0' )
  w_flags[1] = widget_button(w_flag, value=flag_names[1], uvalue='1' )
  w_flags[2] = widget_button(w_flag, value=flag_names[2], uvalue='2' )
  w_flags[3] = widget_button(w_flag, value=flag_names[3], uvalue='3' )
  w_flags[4] = widget_button(w_flag, value=flag_names[4], uvalue='4' )
  w_flags[5] = widget_button(w_flag, value=flag_names[5], uvalue='5' )
  tmp = widget_button(base20, value='All', uvalue='all_flags' ) 
  tmp = widget_button(base20, value='None', uvalue='no_flags' )

  fdefault=replicate(0,6)
  flags_index=fdefault

  for i=0,5 do begin
    widget_control, w_flags[i], set_button = fdefault[i]
  endfor
  state= { flag_base: flag_base, w_flags: w_flags, $
    flags_index:flags_index, fdefault:fdefault}
  widget_control, widget_info(flag_base, /child ), set_uvalue=state
  return, flag_base
end